#!/bin/bash

if [ "x$1" == "x" ] ; then
echo "Please specify a dist to build into"
exit
fi

SKIP_BUILD=0
if [ ! -e /usr/bin/bhc ] ; then
    echo "beehive not installed. Will skip make build step"
    echo "Press enter to continue or Ctrl-C to abort now"
    read
    SKIP_BUILD=1
fi

Dist=$1 
DistDir=$HOME/dist/
COLLINST=$2

# the name of the spec file, the command used to build a tar
# ball, and the package name differs so look for it in build_info
source build_info
# an example build_info script (sans the leading #)
#NAME="up2date"
#MAKETAR="../build/build --beehive --tarball up2date"
#SPECFILE="up2date.spec"


echo $SPECFILE
echo $NAME
echo $MAKETAR

VERSION=`rpm -q --qf "%{VERSION}\n" --specfile $SPECFILE | head -1 `
RELEASE=`rpm -q --qf "%{RELEASE}\n" --specfile $SPECFILE | head -1 `

echo $VERSION
echo $RELEASE

# build a tarball
$MAKETAR
# mv/cp tarball to approriate dist
# do we need to allow packages to override this?
TARBALL=$NAME-$VERSION$TARBALLSUF
mv ./$TARBALL $DistDir/$NAME/$Dist/

# mv specfile to approriate location
cp $SPECFILE $DistDir/$NAME/$Dist/
# cd to approriate dist
echo "changing to $DistDir/$NAME/$Dist"
pushd $DistDir/$NAME/$Dist
# make new-source FILES=$TARBALL
make new-source FILES=$TARBALL
# commit the bits
cvs commit -m \"$VERSION-$RELEASE\" $SPECFILE sources .cvsignore
make tag

if [ $SKIP_BUILD == 1 ] ; then
    echo "beehive not installed. Skipping 'make build'."
    exit
fi

if [ "x$COLLINST" != "x" ] ; then
	make build  COLLECTION=$COLLINST;
else 
	make build;
fi


