#!/usr/bin/python

import sys
import os
import string
import rpm
sys.path.append("../")

import up2dateErrors 
# lots of useful util methods for building/tearing down
# test enviroments...
import testutils

import unittest

import rhnChannel
#import genericTestRepo

#Import the modules you need to test...
#from repoBackends import dirRepo

def write(blip):
    sys.stdout.write("\n|%s|\n" % blip)


class TestGenericRepoSource(unittest.TestCase):
    def __init__(self, methodname):

        unittest.TestCase.__init__(self, methodname)
    
    def setUp(self):
        import glob
        files = glob.glob("/var/spool/up2date/%s*" % self.channelname)
        for file in files:
            os.unlink(file)
	self.__setupData()

    def __setupData(self):
        import testutils
        testutils.setupConfig(self.configname)

    def tearDown(self):
        import testutils
        testutils.restoreConfig()
        
    def testEmptyInit(self):
        "Verify that the class can be created with no arguments"
        repo = self.initRepoClass()

    def initRepoClass(self, cacheObject=None):
	if cacheObject != None:
	    rc = self.repoClass(cacheObject=cacheObject)
	rc = self.repoClass()
        if cacheObject != None:
            rc.psc.headerCache = cacheObject

        return rc

    def _listPackages(self):
        repo = self.initRepoClass()
        channels = rhnChannel.getChannels()
        channel = channels.getByLabel(self.channelname)

        ret = repo.listPackages(channel)
        return ret

    def _listAllPackages(self):
        repo = self.initRepoClass()
        channels = rhnChannel.getChannels()
        channel = channels.getByLabel(self.channelname)

        ret = repo.listAllPackages(channel)
        return ret

    def testListPackages(self):
        "Verify that listPackages runs without error"
        ret = self._listPackages()

    def _verifyFormat(self, data):
        broken = 0
        if type(data) == type([]):
            if type(data[0]) == type([]):
                if type(data[0][0]) == type(""):
                    pass
                elif type(data[0][1]) == type(""):
                    pass
                elif type(data[0][2]) == type(""):
                    pass
                elif type(data[0][3]) == type(""):
                    pass
                elif type(data[0][4]) == type(1):
                    pass
                elif type(data[0][5]) == type(""):
                    pass
                elif type(data[0][6]) == type(""):
                    pass
                else:
                    broken = 1
        return broken

    def testListPackagesReturnFormat(self):
        "Verify that listPackages returns data in the correct format"
        ret = self._listPackages()
        broken = self._verifyFormat(ret)
        assert broken == 0

    def testListAllPackages(self):
        "Verify that listAllPackages runs without error"
        ret = self._listAllPackages()

    def testListAllPackagesReturnFormat(self):
        "Verify that listAllPackages returns the right data format"
        ret = self._listAllPackages()
        broken = self._verifyFormat(ret)
        assert broken == 0

    def _getObsoletes(self):
        repo = self.initRepoClass()
        channels = rhnChannel.getChannels()
        channel = channels.getByLabel(self.channelname)

        ret = repo.getObsoletes(channel)
        return ret

    def _getObsoletesListPackages(self):
        repo = self.initRepoClass()
        channels = rhnChannel.getChannels()
        channel = channels.getByLabel(self.channelname)

        pl = repo.listPackages(channel)
        ret = repo.getObsoletes(channel)
        return ret


    def testGetObsoletesNoListPackages(self):
        "Verify that getObsoletes runs without error when listPackages hasnt ran"
        ret = self._getObsoletes()

    def testGetObsoletesListPackages(self):
        "Verify that getObsoletes runs without error when listPackages has ran"
        ret = self._getObsoletesListPackages()


    def _getHeader(self, pkg):
        import rpmSource
        repo = self.initRepoClass()
        channels = rhnChannel.getChannels()
        channel = channels.getByLabel(self.channelname)

        pl = repo.listPackages(channel)

        
        h = repo.getHeader(pkg)
        
    def testGetHeader(self):
        "Verify that getHeader runs without error"
#        pkg = ["htmlview", "3.0.0", "3", "", "noarch", 6279,
#               "directory-testrpms", "/usr/src/rhn/up2date/test/test-packages/signed-fedora-key-1.1-1.1.noarch.rpm"]
        ret = self._getHeader(self.pkgToGet)
        
    def _getPackages(self, pkg):
        import rpmSource
        hc = rpmSource.HeaderCache()
        repo = self.initRepoClass(cacheObject = hc)
        channels = rhnChannel.getChannels()
        channel = channels.getByLabel(self.channelname)

        pl = repo.listPackages(channel)

        p = repo.getPackage(pkg)
        return p

    def testGetPackage(self):
        "Verify that getPackage runs without error"
        p = self._getPackages(self.pkgToGet)

##class TestDirRepoSolveDep(unittest.TestCase):
##    def setUp(self):
##        import glob
##        files = glob.glob("/var/spool/up2date/directory-testrpms*")
##        for file in files:
##            os.unlink(file)
##	self.__setupData()

##    def __setupData(self):
##        import testutils
##        testutils.setupConfig("fc2-dir-sources-1")

##    def tearDown(self):
##        import testutils
##        testutils.restoreConfig()

##    def testSolveDep(self):
##        "Verify that DirSolveDep runs without error"
##        sd = dirRepo.DirSolveDep()
##        ret = sd


 
if __name__ == "__main__":
    import sys
    import myunittest
    myunittest.main(argv=sys.argv, covmodule=dirRepo)

    

