#!/usr/bin/python


import sys
sys.path.append("../")

import unittest

import rpm
import packageList
#import rhnUnittest
import config
cfg = config.initUp2dateConfig()

def write(blip):
    sys.stdout.write("\n|%s|\n" % blip)

#testCase = profileUnittest.TimedTestCase


# empty version, should work even in cases with no data
# available..
#class testPackageList(rhnUnittest.RhnTestCase):
class TestPackageList(unittest.TestCase):
    def setUp(self):
        import testutils
        testutils.setupConfig("rhel3-i386")
        self.pl = packageList.PackageList()
        self.populateResults()
        import rhnPackageInfo
        rhnPackageInfo.avail_package_lst = self.availablePackageList

    def getAuth(self):
        import up2dateAuth
        up2dateAuth.updateLoginInfo()

    def populateResults(self):
        self.getInstalledPackagesResult = {'a0000': [['a0000', '1.0', '1', '', 'noarch']],
                                            'a0001': [['a0001', '1.0', '1', '', 'noarch']],
                                            'a0002': [['a0002', '1.0', '1', '', 'noarch']]}

        
        self.getInstalledPackagesResultMultilib = {'a0000': [['a0000', '1.0', '1', '', 'i386'],
                                                             ['a0000', '1.0', '1', '', 'x86_64']],
                                                   'a0001': [['a0001', '1.0', '1', '', 'i386'],
                                                             ['a0001', '1.0', '1', '', 'x86_64']],
                                                   'a0002': [['a0002', '1.0', '1', '', 'i386'],
                                                             ['a0002', '1.0', '1', '', 'x86_64']]
                                                   }


        self.availablePackageList = [['a0000', '3.0', '1', '', 'noarch', '123123', 'test-channel-foobar'],
                                     ['a0001', '1.0', '1', '', 'noarch', '123123', 'test-channel-foobar'],
                                     ['blippy', '3.0', '1', '', 'noarch', '123123', 'test-channel-foobar'],
                                     ['foobar', '3.0', '1', '', 'noarch', '123123', 'test-channel-foobar'],
                                     ['a0002', '0.9', '1', '', 'noarch', '123123', 'test-channel-foobar'],]
        self.getForcedPackagesResults = {'a0040': None,
                                         'a0060': None,
                                         'a0065': None,
                                         'a0050': None,
                                         'a0035': None,
                                         'a0055': None,
                                         'a0025': None,
                                         'a0030': None,
                                         'a0020': None,
                                         'a0045': None}

        self.skipPatterns = ['a0000*', 'kernel*']
        self.skippedPackages = [(['a0000', '2.0', '1', '', 'noarch'], 'Pkg name/pattern')]

        self.packagesToUpdate = [['a0000', '2.0', '1', '', 'noarch'],
                                 ['a0001', '2.0', '1', '', 'noarch'],
                                 ['a0002', '2.0', '1', '', 'noarch'],
                                 ['a0003', '2.0', '1', '', 'noarch'],
                                 ['a0004', '2.0', '1', '', 'noarch'],
                                 ['a0005', '2.0', '1', '', 'noarch'],
                                 ['a0006', '2.0', '1', '', 'noarch'],
                                 ['a0007', '2.0', '1', '', 'noarch'],
                                 ['a0008', '2.0', '1', '', 'noarch'],
                                 ['a0009', '2.0', '1', '', 'noarch'],
                                 ['a0010', '2.0', '1', '', 'noarch'],
                                 ['a0011', '2.0', '1', '', 'noarch'],
                                 ['a0012', '2.0', '1', '', 'noarch'],
                                 ['a0013', '2.0', '1', '', 'noarch'],
                                 ['a0014', '2.0', '1', '', 'noarch'],
                                 ['a0015', '2.0', '1', '', 'noarch'],
                                 ['a0016', '2.0', '1', '', 'noarch'],
                                 ['a0017', '2.0', '1', '', 'noarch'],
                                 ['a0018', '2.0', '1', '', 'noarch'],
                                 ['a0019', '2.0', '1', '', 'noarch']]

        
        self.packagesToUpdateNoarchToArch = [['a0000', '2.0', '1', '', 'i686'],
                                             ['a0001', '2.0', '1', '', 'i686'],
                                             ['a0002', '2.0', '1', '', 'i686'],
                                             ['a0003', '2.0', '1', '', 'i686'],
                                             ['a0004', '2.0', '1', '', 'i686'],
                                             ['a0005', '2.0', '1', '', 'i686']]


        self.packagesToUpdateArchToNoarch = [['a0000', '2.0', '1', '', 'noarch'],
                                             ['a0001', '2.0', '1', '', 'noarch'],
                                             ['a0002', '2.0', '1', '', 'noarch'],
                                             ['a0003', '2.0', '1', '', 'noarch'],
                                             ['a0004', '2.0', '1', '', 'noarch'],
                                             ['a0005', '2.0', '1', '', 'noarch']]

        self.packagesToUpdateSkipped =  [['a0001', '2.0', '1', '', 'noarch'],
                                         ['a0002', '2.0', '1', '', 'noarch'],
                                         ['a0003', '2.0', '1', '', 'noarch'],
                                         ['a0004', '2.0', '1', '', 'noarch'],
                                         ['a0005', '2.0', '1', '', 'noarch'],
                                         ['a0006', '2.0', '1', '', 'noarch'],
                                         ['a0007', '2.0', '1', '', 'noarch'],
                                         ['a0008', '2.0', '1', '', 'noarch'],
                                         ['a0009', '2.0', '1', '', 'noarch'],
                                         ['a0010', '2.0', '1', '', 'noarch'],
                                         ['a0011', '2.0', '1', '', 'noarch'],
                                         ['a0012', '2.0', '1', '', 'noarch'],
                                         ['a0013', '2.0', '1', '', 'noarch'],
                                         ['a0014', '2.0', '1', '', 'noarch'],
                                         ['a0015', '2.0', '1', '', 'noarch'],
                                         ['a0016', '2.0', '1', '', 'noarch'],
                                         ['a0017', '2.0', '1', '', 'noarch'],
                                         ['a0018', '2.0', '1', '', 'noarch'],
                                         ['a0019', '2.0', '1', '', 'noarch']]
        
        self.crossArchObsoletesResults = [['a0000', '2.0', '1', '', 'i386'],
                                          ['a0001', '2.0', '1', '', 'i386'],
                                          ['a0001-obs', '2.0', '1', '', 'i386'],
                                          ['a0001-obs', '2.0', '1', '', 'i686'],
                                          ['a0002', '2.0', '1', '', 'i386'],
                                          ['a0003', '2.0', '1', '', 'i386'],
                                          ['a0004', '2.0', '1', '', 'i386'],
                                          ['a0022-obs', '2.0', '1', '', 'noarch']]
        

    def __addInstalledPackages(self, count, multilib=None, arch1=None, arch2=None):
        installedPackageList = []
	if not arch1:
	    arch1 = "noarch"
        for i in range(count):
            if multilib:
                installedPackageList.append(["a%04d" % i, '1.0', '1', '', arch1])
                installedPackageList.append(["a%04d" % i, '1.0', '1', '', arch2])
            else:		
                installedPackageList.append(["a%04d" % i, '1.0', '1', '', arch1])
        self.pl.addInstalledPackages(installedPackageList)

        
    def testAddInstalledPackages(self):
        """Verify PackageList.addInstalledPackages runs with no errors"""
        self.__addInstalledPackages(20)

    def testAddInstalledPackagesMultilib(self):
        """Verify PackageList.addInstalledPackages with multilib pkgs runs with no errors"""
        self.__addInstalledPackages(20, multilib=1, arch1="i386", arch2="x86_64")

    def testGetInstalledPackages(self):
        """Verify that PackageList.getInstalledpackages runs with no errors"""
        self.__addInstalledPackages(3)
        res = self.pl.getInstalledPackages()
        self.assertEqual(res, self.getInstalledPackagesResult)

    def testGetInstalledPackagesMultilib(self):
        """Verify that PackageList.getInstalledpackages with multilib runs with no errors"""
        self.__addInstalledPackages(3, multilib=1, arch1="i386", arch2="x86_64")
        res = self.pl.getInstalledPackages()
        self.assertEqual(res, self.getInstalledPackagesResultMultilib)


    def __addAvailablePackages(self, count, aArch=None):
        availablePackageList = []
        if aArch:
            for i in range(count):
                availablePackageList.append(["a%04d" % i, '2.0', '1','', aArch])
        else:
            for i in range(count):
                for arch in ['noarch', 'i386', 'i586', 'i686', 'athlon']:
                    availablePackageList.append(["a%04d" % i, '2.0', '1', '', arch])
        return self.pl.addAvailablePackages(availablePackageList)

    def testAddAvailablePackages(self):
        """Verify that PackageList.addAvailablePackages runs with no errors"""
        res = self.__addAvailablePackages(20)

    def __AddAvailablePackagesArched(self, arch):
        res = self.__addAvailablePackages(6, aArch=arch)


    def __addForcePackages(self,count):
        forcePackageList = []
        for i in range(count):
            forcePackageList.append("a%04d" % (20 + 5 * i))
        self.pl.addForcePackages(forcePackageList)
        
    def testAddForcePackages(self):
        """Verify that PackageList.addForcePackages runs with no errors"""
        res = self.__addForcePackages(10)

    def testGetForcedPackages(self):
        """Verify that PackageList.getForcedPackages runs with no errors"""
        self.__addForcePackages(10)
        res = self.pl.getForcedPackages()
        self.assertEqual(res, self.getForcedPackagesResults)

    def testAddObsoletePackages(self):
        """Verify that PackageList.addObsoletePackages runs with no errors"""
        obsList = [
            ('a0021', '2.0', '1', '', 'noarch', 'a0019', '', 0),
            ('a0022', '2.0', '1', '', 'noarch', 'a0018', '2.0-1', 2),
            ]
        self.pl.addObsoletePackages(obsList)

    def testAddObsoletePackagesEmptyList(self):
        """Verify that PackageList.addObsoletePackages pass an empty list runs with no errors"""
        obsList = []
        self.pl.addObsoletePackages(obsList)


    def testAddSkipPatterns(self):
        """Verify that PackageList.addSkipPatterns runs with no errors"""
        skipPatterns = ["a0017", "a001[3-5]"]
        self.pl.addSkipPatterns(skipPatterns)

    def testRun(self):
        """Verify that PackageList.run runs with no errors"""
        self.getAuth()
        res = self.pl.run()
        

    def testGetObsoletedPackages(self):
        """Verify that PackageList.addObsoletedPackages runs with no errors"""
        self.getAuth()
        obsList = [
            ('a0021', '2.0', '1', '', 'noarch', 'a0019', '', 0),
            ('a0022', '2.0', '1', '', 'noarch', 'a0018', '2.0-1', 2),
            ]
        self.testAddInstalledPackages()
        self.testAddAvailablePackages()
        self.pl.addObsoletePackages(obsList)
        self.pl.run()
        res = self.pl.getObsoletedPackages()
        
    def testGetPackagesToInstall(self):
        """Verify that PackageList.getPackagesToInstall runs with no errors"""
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackages()
        self.testAddAvailablePackages()
        res = self.pl.getPackagesToInstall()
        self.assertEqual(self.packagesToUpdate, res)
        

    def testGetPackagesToInstallNoarchToArch(self):
        """Verify that PackageList.getPackagesToInstall correctly updates noarch to newer arched package"""
	# see bugzilla #122088
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackages()
        self.__AddAvailablePackagesArched(arch="i686")
        res = self.pl.getPackagesToInstall()
        self.assertEqual(self.packagesToUpdateNoarchToArch, res)

    def testGetPackagesToInstallArchToNoarch(self):
	"""Verify that PackageList.getPackagesToInstall correctly updates arch package to newer noarch package"""
	# bugzilla #127875
	self.getAuth()
	cfg['forceInstall'] = 1
        self.__addInstalledPackages(count=20, arch1="i386")
        self.__AddAvailablePackagesArched(arch="noarch")
	res = self.pl.getPackagesToInstall()
	self.assertEqual(self.packagesToUpdateArchToNoarch, res)	
        
    def testAddSkipPatternsVerify(self):
        """Verify that PackageList respects the list of skip patterns correctly"""
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackages()
        self.testAddAvailablePackages()
        self.pl.addSkipPatterns(self.skipPatterns)
        res = self.pl.getPackagesToInstall()
        self.assertEqual(self.packagesToUpdateSkipped, res)

    def testGetSkippedPackagesVerify(self):
        """Verify that PackageList.getSkippedPackages is correct"""
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackages()
        self.testAddAvailablePackages()
        self.pl.addSkipPatterns(self.skipPatterns)
        res = self.pl.getPackagesToInstall()
        res = self.pl.getSkippedPackages()
        self.assertEqual(self.skippedPackages, res)

    def testAddCompsEmptyComps(self):
        """Verify that PackageList.addComps with an empty compslist works"""
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackages()
        self.testAddAvailablePackages()
        self.compsList1 = []
        self.pl.addComps(self.compsList1)

    def testAddCompsBogusComps(self):
        """Verify that PackageList.addComps with a bogus compslist works"""
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackages()
        self.testAddAvailablePackages()
        self.compsList2 = ["Foobar", "BogusComp"]
        self.pl.addComps(self.compsList2)

    def testCrossArchObsoletes(self):
        """Verify that multilib packages that obsolete something, the approriate arch is picked"""
        # this is based on #119073
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackagesMultilib()
        self.__addAvailablePackages(count=5)
        obsList =  [
            ('a0001-obs', '2.0', '1', '', 'i386', 'a0001', '', 0),
            ('a0001-obs', '2.0', '1', '', 'i686', 'a0001', '', 0),
            ('a0022-obs', '2.0', '1', '', 'noarch', 'a0018', '2.0-1', 2),
            ]

        # need to make sure the obsoleting packages are in the availablelist as well
        avObsList = []
        for i in obsList:
            avObsList.append(list(i[:5]))
        self.pl.addAvailablePackages(avObsList)
        self.pl.addObsoletePackages(obsList)
        res = self.pl.getPackagesToInstall()
	write(res)
	assert res == self.crossArchObsoletesResults
        

##    def testAddCompsLocalComp(self):
##        """Verify that PackageLIst.addComps works"""
##        self.getAuth()
##        cfg['forceInstall'] = 1
##        cfg['compsFiles'] = ["/var/spool/up2date/testcomps.xml"]

##        #write out a simple comps file
        
##        self.testAddInstalledPackages()
##        self.testAddAvailablePackages()
##        self.compsList2 = ["Foobar", "BogusComp"]
##        self.pl.addComps(self.compsList2)


    def testAddGlobsEmptyList(self):
        """Verify that PackageList.addglobs with an empty globlist works"""
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackages()
        self.testAddAvailablePackages()
        self.globList1 = []
        self.pl.addGlobs(self.globList1)

    def testAddGlobsBogusGlobs(self):
        """Verify that PackageList.addGlobs with an empty globlist works"""
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackages()
        self.testAddAvailablePackages()
        self.globList2 = ["ilikecheese*"]
        self.pl.addGlobs(self.globList2)

    def testAddGlobsSplatTest2(self):
        """Verify that PackageList.addGlobs with a foo* splat glob that doesnt match works"""
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackages()
        self.testAddAvailablePackages()
        self.globList3 = ["a001dfsdfsdfsdf*"]
        self.pl.addGlobs(self.globList3)
        self.pl.run()
        res = self.pl.getPackagesToInstall()
        

    def testAddGlobsSplatTest1(self):
        """Verify that PackageList.addGlobs with a foo* splat glob that matches works"""
        self.getAuth()
        cfg['forceInstall'] = 1
        self.testAddInstalledPackages()
        self.testAddAvailablePackages()
        self.globList4 = ["a00*"]
        self.pl.addGlobs(self.globList4)
        self.pl.run()
        res = self.pl.getPackagesToInstall()
        
if __name__ == "__main__":
    import sys
    import myunittest
    myunittest.main(argv=sys.argv, covmodule=packageList)
    
