#!/usr/bin/python

import sys
import os
import string
import rpm
sys.path.append("../")

import up2dateErrors 
# lots of useful util methods for building/tearing down
# test enviroments...
import testutils

import unittest

import rhnChannel
import genericTestRepo

#Import the modules you need to test...
from repoBackends import up2dateRepo
import up2dateAuth


def write(blip):
    sys.stdout.write("\n|%s|\n" % blip)


class TestDirRepoSource(genericTestRepo.TestGenericRepoSource):
    def __init__(self, methodname):
        self.channelname = "rhel-i386-as-3"
        self.configname = "rhel3-i386"
        self.serverSettings = up2dateRepo.ServerSettings()
        self.li = up2dateAuth.getLoginInfo()
        self.httpServer = up2dateRepo.getGETServer(self.li, self.serverSettings)
        self.repoClass = up2dateRepo.HttpGetSource
        self.proxyHost = None
        self.pkgToGet = ["htmlview", "2.0.0", "10", "", "noarch", 6279,
               "rhel-i386-as-3"]
        genericTestRepo.TestGenericRepoSource.__init__(self, methodname)
    
    def setUp(self):
        import glob
        import up2dateAuth
        self.__setupData()
        up2dateAuth.updateLoginInfo()
        files = glob.glob("/var/spool/up2date/%s*" % self.channelname)
        for file in files:
            os.unlink(file)

    def __setupData(self):
        import testutils
        testutils.setupConfig(self.configname)


    def tearDown(self):
        import testutils
#        testutils.restoreConfig()

    def initRepoClass(self, cacheObject = None):
        if cacheObject != None:
            rc =  self.repoClass(self.httpServer, self.proxyHost, cacheObject = cacheObject)
            rc.headerCache = cacheObject
        else:
            rc = self.repoClass(self.httpServer, self.proxyHost)
        return rc
    
    def _getHeader(self, pkg):
        import rpmSource
        hc = rpmSource.HeaderCache()
        repo = self.initRepoClass(cacheObject = hc)
        channels = rhnChannel.getChannels()
        channel = channels.getByLabel(self.channelname)

        pl = repo.listPackages(channel)

        
        h = repo.getHeader(pkg)
    
##class TestDirRepoSolveDep(unittest.TestCase):
##    def setUp(self):
##        import glob
##        files = glob.glob("/var/spool/up2date/directory-testrpms*")
##        for file in files:
##            os.unlink(file)
##	self.__setupData()

##    def __setupData(self):
##        import testutils
##        testutils.setupConfig("fc2-dir-sources-1")

##    def tearDown(self):
##        import testutils
##        testutils.restoreConfig()

##    def testSolveDep(self):
##        "Verify that DirSolveDep runs without error"
##        sd = dirRepo.DirSolveDep()
##        ret = sd


 
if __name__ == "__main__":
    import sys
    import myunittest
    myunittest.main(argv=sys.argv, covmodule=up2dateRepo)

    

