#!/usr/bin/python

# a script to failsafe rescue up2date in worse case scenario's


import urllib
import string
import sys
import shutil
import os
import time
import glob


# the url to look at for the manifest and config files
# see genRescueURL() as well
BASE_URL="http://sludge.devel.redhat.com/foo/linux/7.2/i386"

# go to url
# grab a manifest
# grab all the files mentioned in that manifest



# this is all crap to hopefully make the http fetching slightly more
# robust
# FIXME: option for proxies (commandline?)

class Error:
    """base class for errors"""
    def __init__(self, errmsg):
        self.errmsg = errmsg
        
    def __repr__(self):
        return self.errmsg
    
class Http404Error(Error):
    def __init__(self, errcode, errmsg):
        self.errmsg = errmsg
        self.errcode = errcode
    def __repr__(self):
        return "%s %s" % (self.errcode, self.errmsg)

class Http403Error(Error):
    def __init__(self, errcode, errmsg):
        self.errmsg = errmsg
        self.errcode = errcode
    def __repr__(self):
        return "%s %s" % (self.errcode, self.errmsg)

# subclass this so we can get an error on 404 at least... bleah
class RhnFancyURLopener(urllib.FancyURLopener):
    def __init__(self, *args):
        apply(urllib.FancyURLopener.__init__, (self,) + args)

    def http_error_404(self, url, fp, errcode, errmsg, headers,
                       data=None):
        fp.close()
        # why does it strip the type off the url?
        errmsg = "http:%s was not found" % url
        raise Http404Error, ( errcode, errmsg)

    def http_error_403(self, url, fp, errcode, errmsg, headers,
                       data=None):
        fp.close()
        errmsg = "http:%s was not accessible to the client" % url
        raise Http403Error, ( errcode, errmsg)


def urlopen(url, data=None):
    _urlopener = RhnFancyURLopener()
    if data is None: 
        return _urlopener.open(url)
    else:
        return _urlopener.open(url, data)

def urlretrieve(url, filename=None, reporthook=None):
    _urlopener = RhnFancyURLopener()
    return _urlopener.retrieve(url, filename, reporthook)

def genRescueUrl():
    # FIXME: decide if we want this to be smarter
    #     ie, including the systemid in it (implys parsing systemid which probabaly
    #     means no...
    # FIXME: determine arch/release the least likely way to break as possible
    #     can we rely on rpm at this point?
    # FIXME: is uname -a good enough for arch? we could add extra symlinks server side
    #      for new arches...
    url = BASE_URL
    return url

# package manifest is just a one package per line text file
def fetchPackageManifest():

    manifest = []
    url = genRescueUrl()
    manifestUrl = "%s/manifest" % url

    fp = urlopen(manifestUrl)
    manifest = fp.readlines()
    fp.close()
    
    #strip newlines
    tmp = []
    for i in manifest:
        tmp.append(string.strip(i))
    return tmp

# might be a good idea for modem folks, but is it worth the risk?
def __progressCallback(blocknum, blocksize, size):
    sofar = blocknum*blocksize

    percent = float(sofar)/float(size)
    if percent >= 1.0:
        percent = 1.0
    print "%.2d %%" % (percent *100)

def fetchFile(filename):
    # FIXME: where do we want to write packages to? /var/spool/up2date?
    # FIXME: create downloadPath if it doesnt exist
    # FIXME: check available space in downloadPath?
    # FIXME: do we want to add info about the total space required to manifest
    #        or handle file by file based on content length
    
    downloadPath = "/var/spool/up2date/"
    url = genRescueUrl()
    fileUrl = "%s/%s" % (url, filename)
    localFilename = "%s/%s" % (downloadPath, filename)
    fp = urlretrieve(fileUrl, localFilename)
    return localFilename
    
def fetchNeededPackages():
    try:
        manifest = fetchPackageManifest()
    except Http404Error:
        # no files to download
        manifest = []
    for file in manifest:
        fetchFile(file)
    return manifest



######## config file mangling ###########

# should I attempt to figure this out from the rpmdb?


def genBackupPath():
    backupPath = "/var/spool/up2date/confbackup-%s/" % time.time()
    return backupPath

def backupConfigFiles(backupPath):
    # for kicks, lets put them in a subdir of /var/spool/up2dat
    #shutil.rmtree(backupPath, ignore_errors=1)
    shutil.copytree("/etc/sysconfig/rhn/", backupPath)
    try:
        shutil.copy("%s/systemid" % backupPath, "/etc/sysconfig/rhn/systemid")
    except IOError:
        # handle chattr?
        # oh well, the file doesnt exist, we cant copy it, etc
        pass

# attempt to copy, but dont bitch if a file here doesnt exist anymore
# the files were copying with this arent all that special anyway
def uglycopy(src, dst):
    try:
        shutil.copy(src, dst)
    except IOError:
        pass
    
def restoreConfigFiles(backupPath):
    # FIXME: parse though the config files rescueing bits?
    # for now, just copy them back
    uglycopy("%s/up2date" % backupPath, "/etc/sysconfig/rhn/up2date")
    uglycopy("%s/rhn_register" % backupPath, "/etc/sysconfig/rhn/rhn_register")
    uglycopy("%s/rhnsd" % backupPath, "/etc/sysconfig/rhn/rhnsd")
    uglycopy("%s/up2date-keyring.gpg" % backupPath, "/etc/sysconfig/rhn/up2date-keyring.gpg")
    # others?



########### Sanify rpm and it's db ##############

def removeLockFiles():
    # FIXME: is this safe to do?
    print "Removing any rpmdb lockfiles that might be stale..."
    rpmdbpath = "/var/lib/rpm/"
    dblockfiles = glob.glob("%s/__db*" % rpmdbpath)
    for lock in dblockfiles:
        print lock
        os.unlink(lock)

def rebuildRPMdb():
    rpmdbrebuild = "rpm --rebuilddb"
    print "Rebuilding the rpm database with the command \"%s\"" % rpmdbrebuild
    ret = os.system(rpmdbrebuild)
    # do I care what it returns? not much I can
    # do if it fails...


def sanitizeRPM():
    removeLockFiles()
    rebuildRPMdb()



########### Install the new packages ################
def installPackages(manifest):
    # FIXME: get packagepath from config/function?
    # FIXME: should I try a normal install first, then a --force --nodeps?
    if len(manifest) == 0:
        print "There are no packages mentioned in the manifest"
    
    pkgs = map(lambda a: "%s/%s" % ("/var/spool/up2date/", a), manifest)
    cmd_string = "rpm -Uvh --force --nodeps %s" % string.join(pkgs, " ")
#    print "TEST: %s" % cmd_string
    #print "TEST: rpm -Uvh %s" % string.join(pkgs, " ")


def update_config(newconfigfile):

    import os
    import sys
    sys.path.append("/usr/share/rhn")
    import up2date_client.config

    # open the new config file as a config object
    newcfg = up2date_client.config.Config(newconfigfile)

    # figure out which file were updating
    filetype = os.path.basename(newconfigfile)
    if filetype == "up2date":
        cfg = config.initUp2dateConfig()
        print "updating the up2date config file"
    elif filetype == "rhn_register":
        cfg = config.initUp2dateConfig("/etc/sysconfig/rhn/rhn_register")
        print "updating the rhn_register config file"

    # merge it with the existing config
    for param in newcfg.keys():
        cfg.set(param, newcfg[param])
    
    del newcfg
    cfg.save()


def updateLocalConfigs():
    # only call this at the point where you know the system
    # has a sane install, since it uses xmlrpc

    # return a filename of the freshly download config
    # files
    up2date_config = None
    register_config = None
    
    try:
        register_config = fetchFile("rhn_register")
    except Http404Error:
        # 404 just means the config file isnt there, which is fine
        print "No config file rhn_register found. Skipping"
    except Http403Error:
        print "Got a 403 Permession Denied error getting that file"

    try:
        up2date_config = fetchFile("up2date")
    except Http404Error:
        print "No Config for up2date found. Skipping"
    except Http403Error:
        print "Got a 403 Permession Denied error getting that file"

    # actually update the configs, this merges
    # the new configs with the old
    if up2date_config:
        update_config(register_config)
    if register_config:
        update_config(up2date_config)

    
def main():
    backupPath = genBackupPath()

    backupConfigFiles(backupPath)
    
    manifest = fetchNeededPackages()

    sanitizeRPM()
    
    installPackages(manifest)

    # yup again!, were officially Paranoid!
    sanitizeRPM()
    
    # not real fond of this idea at the moment
    # attempting to auto-repair config files and merge two seperate versions
    # doesnt seem to fit the "the absolute least we have to do to get up2date going again"
    restoreConfigFiles(backupPath)

    # go fetch custom config info, and update config files as approriate 
    updateLocalConfigs()
            

if __name__ == "__main__":
    main()
    

