#!/usr/bin/python -u
#
# Part of the up2date upgrader, class for handling configuration values
#
# veillard@redhat.com
#
"""Implements a class used to handle the configuration values.
   This is based on up2date Config class and tries to reuse
   the rhn_register and up2date existing settings."""

import sys
import string
sys.path.append("..")
from config import Config, Up2dateConfig, RegisterPeekConfig


debug = 0

class upgradeConfig(Config):
    """Implements a class used to handle the configuration values.
       This is based on up2date Config class and tries to reuse
       the rhn_register and up2date existing settings."""
    def __init__(self):
        Config.__init__(self)
	self.fileName = "/etc/sysconfig/rhn/upgrade"
	self.up2date = Up2dateConfig()
	self.rhn_register = RegisterPeekConfig()

    #
    # save and writeEntry are kept as the default
    #

    #
    # Loads all the config files, self, up2date and rhn_register ones
    #
    def load(self):
        Config.load(self)
	if self.up2date != None:
	    self.up2date.load()
	if self.rhn_register != None:
	    self.rhn_register.load()

    #
    # Check if a given entry is available, checks self, up2date and
    # rhn_register in that order
    #
    def has_key(self, name):
        ret = Config.has_key(name)
	if ret != 0:
	    return ret
        ret = self.up2date.has_key(name)
	if ret != 0:
	    return ret
        ret = self.rhn_register.has_key(name)
	return ret

    #
    # Returns all the keys available
    #
    def keys(self):
        list = Config.keys()
	extra = self.up2date.keys()
	list = list + extra
	extra = self.rhn_register.keys()
	list = list + extra
	return list

    #
    # Returns all the values available
    #
    def values(self):
        list = Config.values()
	extra = self.up2date.values()
	list = list + extra
	extra = self.rhn_register.values()
	list = list + extra
	return list

    #
    # read and returns all the values found
    #
    def readValues(self):
        list = Config.readValues()
	extra = self.up2date.readValues()
	list = list + extra
	extra = self.rhn_register.readValues()
	list = list + extra
	return list

    #
    # read the value for a given entry, checks self, up2date and
    # rhn_register in that order
    #
    def readEntry(self, name):
        ret = Config.readEntry(name)
	if ret != None:
	    return ret
        ret = self.up2date.readEntry(name)
	if ret != None:
	    return ret
        ret = self.rhn_register.readEntry(name)
	return ret

    #
    # Check if a given entry is available, checks self, up2date and
    # rhn_register in that order
    #
    def hasEntry(self, name):
        ret = Config.hasEntry(name)
	if ret != 0:
	    return ret
        ret = self.up2date.hasEntry(name)
	if ret != 0:
	    return ret
        ret = self.rhn_register.hasEntry(name)
	return ret

if __name__ == "__main__":
    config = upgradeConfig()
    config.load()
